<?php
	/*************
	Version:	0.0.6
	Author: 	Basti85
	Date:		24.08.2013
	**************/
	
	include_once("config.siri.php");
	
	checkHashKey(@$_GET['hashkey']);	
	
	$configs = IPS_GetObject(SIRI_ROOT);
	$configs = @unserialize($configs['ObjectInfo']);
	
	$_GET['values'] = str_replace("sS","ß",$_GET['values']);
	$values = " ".str_replace(" ","  ",urldecode($_GET['values']))." ";
	$_GET['location'] = str_replace("sS","ß",@$_GET['location']);
	if ($_GET['location'] == NULL) {$_GET['location']="ZUHAUSE";}
	$location = urldecode($_GET['location']);
	$stateValues = array();
	
	// HOOK: Values
		foreach( glob(dirname(__FILE__) . '/values/*.values.php') as $class_path ) require_once( $class_path );
	
	$response = "";
	$LV = getLinkValues();
	$DLV = getDirectLinkValues();
	$CV = getCategoryValues();
	$SV = getStateValues();
	
	if (preg_match('/^ (schweig|schweige|schweigen) /',$values,$results)) {
		addToSay("Wie du willst, ab jetzt bin ich still!");
		$configs['silent'] = true;
		goto end;
	} elseif (preg_match('/^ (sprich|rede) /',$values,$results)) {
		$configs['silent'] = false;
		addToSay("Ich rede sehr gerne wieder mit dir!");
		goto end;
	} elseif (preg_match('/^ Hilfe ( deaktivieren | ausschalten | aus ) /',$values,$results)) {
		addToSay("Die Hilfefunktion ist nun deaktiviert");
		$configs['help'] = false;
		goto end;
	} elseif (preg_match('/^ Hilfe ( aktivieren | einschalten | ein ) /',$values,$results)) {
		addToSay("Die Hilfefunktion ist nun aktiviert");
		$configs['help'] = true;
		goto end;
	}
	elseif (preg_match('/^(?P<CATEGORIES>.*'.$CV.'(?: und )?)?(?P<LINKS>.*'.$LV.'(?: und )?)?(?P<HELP> '.SIRI_KEYWORD_HELP.' ){1}/',$values,$results)) {}
	elseif (preg_match('/^(?P<LINKS>.*'.$DLV.'(?: und )?)?(?P<HELP> '.SIRI_KEYWORD_HELP.' ){1}/',$values,$results)) {}
		
	elseif (preg_match('/^(?P<LINKS>.*'.$LV.'(?: und )?)+(?P<CATEGORIES>.*'.$CV.'(?: und )?)+.*(?: auf )(?P<STATE> [0-9]+ ) (?P<UNIT>[%]{1})/',$values,$results)) {}
	elseif (preg_match('/^(?P<CATEGORIES>.*'.$CV.'(?: und )?)+(?P<LINKS>.*'.$LV.'(?: und )?)+.*(?: auf )(?P<STATE> [0-9]+ ) (?P<UNIT>[%]{1})/',$values,$results)) {}
	
	// ToDo:	STATE für Zahlen? z.B. Temperatur, Zeiten, ...
		
	elseif (preg_match('/^(?P<LINKS>.*'.$LV.'(?: und )?)+(?P<CATEGORIES>.*'.$CV.'(?: und )?)+.*(?: auf  Position | auf )(?P<STATE> .+)/',$values,$results)) {}
	elseif (preg_match('/^(?P<CATEGORIES>.*'.$CV.'(?: und )?)+(?P<LINKS>.*'.$LV.'(?: und )?)+.*(?: auf  Position | auf )(?P<STATE> .+)/',$values,$results)) {}
		
	elseif (preg_match('/^(?P<LINKS>.*'.$LV.'(?: und )?)+(?P<CATEGORIES>.*'.$CV.'(?: und )?)+.*'.$SV.'/',$values,$results)) {}
	elseif (preg_match('/^(?P<CATEGORIES>.*'.$CV.'(?: und )?)+(?P<LINKS>.*'.$LV.'(?: und )?)+.*'.$SV.'/',$values,$results)) {}
			
	elseif (preg_match('/^(?P<LINKS>.*'.$LV.'(?: und )?)+(?P<CATEGORIES>.*'.$CV.'(?: und )?)+/',$values,$results)) {}
	elseif (preg_match('/^(?P<CATEGORIES>.*'.$CV.'(?: und )?)+(?P<LINKS>.*'.$LV.'(?: und )?)+/',$values,$results)) {}
		
	elseif (preg_match('/^(?P<LINKS>.*'.$DLV.'(?: und )?)+(?: auf )(?P<STATE> [0-9]+ ) [%]{1}/',$values,$results)) {}
	elseif (preg_match('/^(?P<LINKS>.*'.$DLV.'(?: und )?)+.*(?: auf )(?P<STATE>.*)/',$values,$results)) {}
		
	elseif (preg_match('/^(?P<LINKS>.*'.$DLV.'(?: und )?)+.*'.$SV.'/',$values,$results)) {}
	elseif (preg_match('/^(?P<LINKS>.*'.$DLV.'(?: und )?)+/',$values,$results)) {}
	else {
		stop();
	}
	
	preg_match_all('/'.$CV.'( UND )?/',(isset($results['CATEGORIES']) ? $results['CATEGORIES'] : ""),$categories);
	if (preg_match_all('/'.$LV.'( UND )?/',@$results['LINKS'],$links)) {}
	elseif (preg_match_all('/'.$DLV.'( UND )?/',@$results['LINKS'],$links)) {}
	
	$source = array(
		"LINKS" => @$links['LINK'],
		"CATEGORIES" => @$categories['CATEGORY'],
		"STATE" => strtoupper(str_replace("  "," ",trim(@$results['STATE']))),
	);
	if (isset($results['HELP'])) {$source['HELP'] = str_replace("  "," ",trim(@$results['HELP'])); }
	if (isset($results['UNIT'])) {$source['UNIT'] = str_replace("  "," ",trim(@$results['UNIT'])); }
	
	if (SIRI_ALLOW_HELP === true && isset($source['HELP']) && @$configs['help'] !== false) {
		siriHelp($source);
	} else {
		$source['HELP'] = NULL;
		siriAction($source);
	}
	
	
	// FUNCTIONS
	
	function siriHelp($source) {
		global $stateValues,$response,$location;
		$ccs = count($source['CATEGORIES']);
		$cls = count($source['LINKS']);
		if ($cls >= 1) {
			// Help STATE
			$categoryName = " ";
			$categoryID = SIRI_ROOT;
			if ($ccs >= 1) {
				$categoryName = str_replace("  "," ",trim($source['CATEGORIES'][0]));
				$categoryID = @IPS_GetObjectIDByName(utf8_decode($categoryName), SIRI_ROOT);
			}
			siriActionLinkByName($source,$categoryName,$categoryID,$source['LINKS'][0]);
		} elseif ($ccs >= 1) {
			// Help Ebene 2
			$categoryName = str_replace("  "," ",trim($source['CATEGORIES'][0]));
			$categoryID = @IPS_GetObjectIDByName(utf8_decode($categoryName), SIRI_ROOT);
			addToAsk('Für '.$categoryName.' gibt es folgende Aktionen: '."\n".siriHelpGetChilds($categoryID)."\n"."\n"."Welchen dieser Werte meintest du?","values=$categoryName "," Hilfe");	
		} elseif ( $ccs < 1 && $cls < 1) {
			// Help Ebene 1
			addToAsk('Bitte wähle aus folgenden Möglichkeiten aus: '."\n".siriHelpGetChilds(SIRI_ROOT)."\n"."\n"."Welche dieser Möglichkeiten möchtest du?","values="," Hilfe");	
		}
	}
	
	function siriHelpGetChilds($id) {
		$linkNames = array();
		foreach (IPS_GetChildrenIDs($id) as $childID) {
			$linkname = IPS_GetName($childID);
			$linkNames[str_replace(" ","",strtoupper($linkname))] = strtoupper($linkname);
		}
		sort($linkNames);
		$text = "";
		foreach ($linkNames as $k => $v) {
			$text.=''.$v.','."\n";
		}
		$text = utf8_encode(substr($text,0,-2));
		return $text;
	}
	
	function siriAction($source) {
		global $stateValues,$response,$location;
		
		if (count($source['CATEGORIES']) < 1) { $source['CATEGORIES'] = array(" ");}
		foreach ($source['CATEGORIES'] as $categoryName) {
			siriActionCategorieByName($source,$categoryName);
		}
	}
	
	function siriActionCategorieByName($source,$categoryName) {
		global $stateValues,$response,$location;
		// CATEGORIES
		$categoryName = str_replace("  "," ",trim($categoryName));
		$categoryID=SIRI_ROOT;
		if ($categoryName !== "") {
			$categoryID = @IPS_GetObjectIDByName(utf8_decode($categoryName), SIRI_ROOT);
		} 
		foreach ($source['LINKS'] as $linkName) {
			siriActionLinkByName($source,$categoryName,$categoryID,$linkName);
		}
	}
	
	function siriActionLinkByName($source,$categoryName,$categoryID,$linkName) {
		global $stateValues,$response,$location;
		// LINKS
		$linkName = str_replace("  "," ",trim($linkName));
		$linkID = @IPS_GetObjectIDByName(utf8_decode($linkName), $categoryID);
		if (isset($linkID) && $linkID > 0) {
			$link = IPS_GetLink($linkID);
			$linkTargetID = $link['LinkChildID'];
			$obj = IPS_GetObject($linkTargetID);
			if ($obj['ObjectType'] == 1) {
				siriActionLinkInstances($source,$categoryName,$linkName,$linkTargetID);
			} elseif ($obj['ObjectType'] == 2) {
				siriActionLinkVariable($source,$categoryName,$linkName,$linkTargetID);
			} elseif ($obj['ObjectType'] == 3) {
				siriActionLinkScript($source,$categoryName,$linkName,$linkTargetID);
			}
		} else {
			stop(); 
		}
	}
	
	function siriActionLinkInstances($source,$categoryName,$linkName,$linkTargetID) {
		global $stateValues,$response,$location;
		// INSTANCE
		$instance = IPS_GetInstance($linkTargetID);
		$objStatusVars = @IPS_GetStatusVariableIdents($linkTargetID);
		// HOOK: Modules
			foreach( glob(dirname(__FILE__) . '/modules/*.modules.php') as $class_path ) require_once( $class_path );
	}
	
	function siriActionLinkScript($source,$categoryName,$linkName,$linkTargetID) {
		global $stateValues,$response,$location;
		// SCRIPT
		if (isset($source['STATE']) && $source['STATE'] != "" && isset($stateValues['script'][strtolower($source['STATE'])]) && $stateValues['script'][strtolower($source['STATE'])]==true) {
			IPS_RunScript($linkTargetID);
			addToSay($categoryName." ".$linkName.'" wird ausgeführt!');
		} else {
			// ToDo:	Soll das Script ausgeführt werden?
			addToAsk("Soll \"$categoryName $linkName\" ausgeführt werden?","values=$categoryName $linkName ");
		}
	}
	
	function siriActionLinkVariable($source,$categoryName,$linkName,$linkTargetID) {
		global $stateValues,$response,$location;
		// VARIABLE
		$obj = IPS_GetObject($linkTargetID);
		$variable = IPS_GetVariable($linkTargetID);
		$value=NULL;
		if (isset($source['STATE']) && $source['STATE'] != "" && !isset($source['HELP'])) {
			if ($variable['VariableCustomAction'] > 1) {
				$value = getVariableValueByText($linkTargetID,NULL,$source['STATE']);
				if ($value !== NULL) {
					// Variable anhand der Assoziation speichern
					IPS_RunScriptEx($variable['VariableCustomAction'],array("VARIABLE" => $linkTargetID, "VALUE" =>$value));
					addToSay("Erledigt!");
					responseVariableValue($linkTargetID,$categoryName,$linkName,$obj['ObjectName'],NULL,$value);
				} elseif (true == false) {
					// ToDo: Variablen anhand des Wertes speichern
				} else {
					$text = getVariableProfileAssociations($linkTargetID);
					addToSay('Der Status "'.$source['STATE'].'" ist für '.$categoryName." ".$linkName." unbekannt!");
					addToAsk('Es werden folgende Werte akzeptiert: '."\n".$text."\n"."\n"."Welchen dieser Werte meintest du?","values=$categoryName $linkName auf ");
				}
			} else {
				// ToDo:	Variable ohne CustomAction speichern
			}
		} elseif (isset($source['HELP'])) {
			$text = getVariableProfileAssociations($linkTargetID);
			addToAsk('Für'.$categoryName." ".$linkName.' sind folgende Werte möglich: '."\n".$text."\n"."\n"."Welchen dieser Werte willst du?","values=$categoryName $linkName auf ");
		} else {
			responseVariableValue($linkTargetID,$categoryName,$linkName,$obj['ObjectName'],NULL,$value);
		}
	}
	
	function responseVariableValue($linkTargetID,$categoryName,$linkName,$name,$statusVar,$value){
		$translations = array("TEMPERATURE" => 'Temperatur', "HUMIDITY" => "Luftfeuchtigkeit", "BRIGHTNESS"=>"Helligkeit","WIND_SPEED" => "Windgeschwindigkeit", "WIND_DIRECTION_RANGE" => "Windrichtungsschwankung");
		switch($name) {
			case "TEMPERATURE":
			case "HUMIDITY":
			case "BRIGHTNESS":
			case "WIND_SPEED":
			case "WIND_DIRECTION_RANGE":
				if ($categoryName != "") {
					addToSay("Die $translations[$name] im ".$categoryName." beträgt ".getVariableTextByValue($linkTargetID,$statusVar,$value).".");
				} else {
					addToSay("Die ".$linkName." beträgt ".getVariableTextByValue($linkTargetID,$statusVar,$value).".");
				}
				break;
			case "RAINING":
				$r = getVariableTextByValue($linkTargetID,$statusVar,$value);
				if ($r == "Trocken") {
					addToSay("Im ".$categoryName." ist es trocken und regnet nicht.");
				} else {
					addToSay("Im ".$categoryName." regnet es.");
				}
				break;
			case "WIND_DIRECTION":
				addToSay("Der Wind kommt im ".$categoryName." aus ".getVariableTextByValue($linkTargetID,$statusVar,$value).".");
				break;
			case "VALVE_STATE":
				addToSay("Das Heizungsventil im ".$categoryName." ist zu ".getVariableTextByValue($linkTargetID,$statusVar,$value)." geöffnet.");
				break;
			default:
				addToSay($categoryName." ".$linkName." ist ".getVariableTextByValue($linkTargetID,$statusVar,$value).".");
				break;
		}
	}
	
	function getStateValues() {
		global $stateValues;
		$text = "(?P<STATE> ";
		foreach ($stateValues as $typ) {
			$text .= strtolower(implode(" | ",array_keys($typ)))." | ".strtoupper(implode(" | ",array_keys($typ)))." | ".ucwords(strtolower(implode(" | ",array_keys($typ))))." | ";
		}
		$text = substr($text,0,-2)."){1}";
		return $text;
	}
	
	function addToSay($text) {
		global $response,$configs;
		$spoken="";
		if (isset($configs['silent']) && $configs['silent']==true) {
			$spoken=', spoken: "" ';
		}
		$response .= 'say "'.str_replace('"','\"',$text).'"'.$spoken."\n";
	}

	function addToAsk($question="",$urlValues="",$pastUrlValues="") {
		global $response,$configs,$location;
		$spoken="";
		if (isset($configs['silent']) && $configs['silent']==true) {
			$spoken=', spoken: "" ';
		}
		$response .= 'response = ask "'.str_replace('"','\"',$question).'"'.$spoken."\n";
		$response .= "response = response.force_encoding('UTF-8')"."\n";
		$response .= "urlValues = \"$urlValues\".force_encoding('UTF-8')"."\n";
		$response .= "pastUrlValues = \"$pastUrlValues\".force_encoding('UTF-8')"."\n";
		$response .= "result = IPSRequest('$location',\"#{urlValues}#{response}#{pastUrlValues}\")"."\n";
		$response .= "eval(result)"."\n";
	}
	
	function getCategoryValues() {
		$root = IPS_GetObject(SIRI_ROOT);
		$categories = array();
		foreach ($root['ChildrenIDs'] as $rootChild) {
			$rootChild = IPS_GetObject($rootChild);
			if ($rootChild['ObjectType'] == 0) {
				$categories[str_replace(" ","  ",utf8_encode($rootChild['ObjectName']))] = 1 ;
			}
		}
		return "(?P<CATEGORY> ".implode(" | ",array_keys($categories))." )";
	}
	
	function getDirectLinkValues() {
		$root = IPS_GetObject(SIRI_ROOT);
		$links = array();
		foreach ($root['ChildrenIDs'] as $rootChild) {
			$rootChild = IPS_GetObject($rootChild);
			if ($rootChild['ObjectType'] == 6) {
				$links[str_replace(" ","  ",utf8_encode($rootChild['ObjectName']))] = 1 ;
			}
		}
		return "(?P<LINK> SSSSSSSSSS | ".implode(" | ",array_keys(array_reverse($links)))." )";
	}
	
	function getLinkValues() {
		$root = IPS_GetObject(SIRI_ROOT);
		$links = array();
		foreach ($root['ChildrenIDs'] as $rootChild) {
			$rootChild = IPS_GetObject($rootChild);
			foreach ($rootChild['ChildrenIDs'] as $child) {
				$child = IPS_GetObject($child);
				$links[str_replace(" ","  ",utf8_encode($child['ObjectName']))] = 1 ;
			}
		}
		return "(?P<LINK> ".implode(" | ",array_keys($links))." )";
	}
	
	function getVariableTextByValue($id=0,$childname=NULL,$state=NULL) {
		if ($childname != NULL) {
			$id = @IPS_GetObjectIDByName($childname, $id);
		}
		$p = @IPS_GetVariable($id);
		if ($p['VariableCustomProfile'] != "") {
			$p = $p['VariableCustomProfile']; 
		} else {
			$p = $p['VariableProfile']; 
		}
		$p = @IPS_GetVariableProfile($p);
		$text = "";
		if ($state===NULL) {
			$state=@GetValue($id);
		}
		if (count($p['Associations'])>=1) {
			foreach ($p['Associations'] as $key => $v) {
				if ($v['Value'] <= $state) {
					$text = utf8_encode($p['Prefix'].$v['Name'].$p['Suffix']);	
				}
			}
		} else {
			if (trim($p['Suffix']) == "%" && $p['ProfileType'] == 2) {$state*=100.0;}
			if ($p['Digits'] > 0) { $state = number_format($state, $p['Digits'], ',', '.');}
			$text = utf8_encode($p['Prefix'].$state.$p['Suffix']);
		}
		return $text;
	}
	
	function getVariableValueByText($id=0,$childname=NULL,$state=NULL) {
		if ($childname != NULL) {
			$id = @IPS_GetObjectIDByName($childname, $id);
		}
		$p = IPS_GetVariable($id);
		if ($p['VariableCustomProfile'] != "") {
			$p = $p['VariableCustomProfile']; 
		} else {
			$p = $p['VariableProfile']; 
		}
		$p = IPS_GetVariableProfile($p);
		$text = NULL;
		if ($state===NULL) {
			$state = GetValue($id);
		}
		if (count($p['Associations'])>=1) {
			foreach ($p['Associations'] as $key => $v) {
				if (strtoupper(str_replace(" ","",$v['Name'])) == utf8_decode(strtoupper(str_replace(" ","",$state)))) {
					$text = $v['Value'];
				}
			}
		} /*else {
			$text = $state;
		}*/
		return $text;
	}
	
	function getVariableProfileAssociations($id=0,$additions=array()) {
		$p = IPS_GetVariable($id);
		if ($p['VariableCustomProfile'] != "") {
			$p = $p['VariableCustomProfile']; 
		} else {
			$p = $p['VariableProfile']; 
		}
		$p = IPS_GetVariableProfile($p);
		$a = NULL;
		if (count($p['Associations'])>=1) {
			$a = array();
			foreach ($p['Associations'] as $key => $v) {
				$a[strtoupper($v['Name'])] = $v['Value'];
			}
		}
		if (count($additions) > 0) {
			foreach ($additions as $addition) {
				$a[strtoupper($addition)] = true;
			}
		}
		$text = "";
		foreach ($a as $k => $v) {
			$text.= strtoupper($k).','."\n";
		}
		$text = utf8_encode(substr($text,0,-2));
		return $text;
	}
	
	function stop() {
		global $_GET,$response;
		addToSay('Ich habe keine passende Aktion für "'.urldecode($_GET['values']).'" gefunden!');
		die($response);
	}
	
	function checkHashKey($key) {
		global $response;
		if ($key !== SIRI_HASHKEY) {
			addToSay('Ihre Anfrage konnte nicht autorisiert werden!');
			die($response);
		}
	}
	
	end:
	echo $response;
	@IPS_SetInfo(SIRI_ROOT,serialize($configs));
?>