<?php
	/*************
	Version:	0.0.6
	Author: 	Basti85
	Date:		24.08.2013
	**************/
	if ($instance['ModuleInfo']['ModuleName'] == 'HomeMatic Device') {
		$allowStaturVars = array("STATE","LEVEL","TEMPERATURE","HUMIDITY","SETPOINT","VALVE_STATE","RAINING","BRIGHTNESS","WIND_SPEED","WIND_DIRECTION","WIND_DIRECTION_RANGE");
		foreach ($objStatusVars as $statusVar) {
			if (in_array($statusVar, $allowStaturVars)) {
				$objName = $statusVar;
				$statusVariable = IPS_GetStatusVariable($linkTargetID,$statusVar);
				$variable = IPS_GetVariable($statusVariable['VariableID']);
				$value=NULL;
				if (isset($source['STATE']) && $source['STATE'] != "" && $statusVariable['VariableHasAction'] == 1 && $statusVariable['VariableUseAction'] == 1 && $variable['VariableCustomAction'] != 1 && !isset($source['HELP'])) {
					if ($statusVar == "STATE") {
						// Schaltaktor	
						$text = @getVariableValueByText($statusVariable['VariableID'],NULL,$source['STATE']);
						if ($text !== NULL) {
							$value = $text;
							HM_WriteValueBoolean($linkTargetID, $statusVar, (bool)$value);
							addToSay("Erledigt!");
							responseVariableValue($linkTargetID,$categoryName,$linkName,$objName,$statusVar,$value);
						} elseif (isset($stateValues['boolean'][strtolower($source['STATE'])])) {
							$value = $stateValues['boolean'][strtolower($source['STATE'])];
							HM_WriteValueBoolean($linkTargetID, $statusVar, $value);
							addToSay("Erledigt!");
							responseVariableValue($linkTargetID,$categoryName,$linkName,$objName,$statusVar,$value);
						} else {
							addToSay($categoryName." ".$linkName." kann über den Befehl \"".$source['STATE']."\" nicht geschaltet werden!");
						}
					} elseif ($statusVar == "LEVEL") {
						// Dimmer
							$bool = @$stateValues['boolean'][strtolower($source['STATE'])];
							$text = @getVariableValueByText($statusVariable['VariableID'],NULL,$source['STATE']);
							$p = IPS_GetVariable($statusVariable['VariableID']);
							if ($p['VariableCustomProfile'] != "") {
								$p = $p['VariableCustomProfile']; 
							} else {
								$p = $p['VariableProfile']; 
							}
							$p = IPS_GetVariableProfile($p);
							if ($text !== NULL) {
								// Find value in association?
								$value = $text;	
							} elseif ($bool==true) {	// MAX
								// Find value in boolean?
								if (isset($p['MaxValue'])) {
									$value = $p['MaxValue'] ;
								} elseif ($statusVariable['VariableType'] == 1) {
									$value = 100 ;
								} else {
									$value = 1.0;
								}
							} elseif ($bool===false) {	// MIN
								// Find value in boolean?
								if (isset($p['MinValue'])) {
									$value = $p['MinValue'] ;
								} else {
									$value = 0;
								}
							} elseif (is_int(@intval($source['STATE'])) /*// ToDo: && wenn % */ ) {
								$value = $p['MinValue'] + ($p['MaxValue']-$p['MinValue'])*intval($source['STATE'])/100.00;
								if ($statusVariable['VariableType'] == 1) {
									$value = intval($value*100);
								}
							}
							if ($statusVariable['VariableType'] == 1) {
								HM_WriteValueInteger($linkTargetID, $statusVar, $value);
							} elseif ($statusVariable['VariableType'] == 2) {
								HM_WriteValueFloat($linkTargetID, $statusVar, $value);
							}
							addToSay("Erledigt!");
							responseVariableValue($linkTargetID,$categoryName,$linkName,$objName,$statusVar,$value);
					}
				} elseif (isset($source['STATE']) && $source['STATE'] != "") {
					addToSay($categoryName." ".$linkName." ist nicht schaltbar!");
					responseVariableValue($linkTargetID,$categoryName,$linkName,$objName,$statusVar,$value);
				} elseif (isset($source['HELP']) && $statusVariable['VariableHasAction'] == 1 && $statusVariable['VariableUseAction'] == 1 && $variable['VariableCustomAction'] != 1) {
					if ($statusVar == "STATE") {
						// HELP for STATE Actor
						$text = getVariableProfileAssociations($statusVariable['VariableID'], array("EIN","AUS"));
						addToAsk('Folgendes ist für "'.$categoryName.' '.$linkName.'" möglich: '."\n".$text."\n"."\n"."Was willst du tun?","values=$categoryName $linkName auf ");	
					} elseif ($statusVar == "LEVEL") {
						$text = getVariableProfileAssociations($statusVariable['VariableID'], array("EIN","AUS"));
						// ToDo:	Wenn %
							$text .= ","."\n"."0-100 %";
						// ToDo:	wenn min und max
							// $text .= ","."\n"."Werte zwischen MIN und MAX";
						addToAsk('Folgendes ist für "'.$categoryName.' '.$linkName.'" möglich: '."\n".$text."\n"."\n"."Was willst du tun?","values=$categoryName $linkName auf ");
					}
				} else {
					responseVariableValue($linkTargetID,$categoryName,$linkName,$objName,$statusVar,$value);
				}
			} 
		}
	}
?>