# encoding: UTF-8

require 'httparty'
require 'uri'

class SiriProxy::Plugin::IPS < SiriProxy::Plugin
  attr_accessor :server
  
  KEYWORDS_ZUHAUSE = "Zu Hause|Zuhause"

  def initialize(config = {})
    self.server = config["server"]
  end
  
  def IPSRequest(location="",value = "")
    value = value.force_encoding('UTF-8').gsub(/ß/, "sS")
    value = URI.escape(value)
    HTTParty.get("#{self.server[location]['protocol']}#{self.server[location]['host']}#{self.server[location]['script']}?hashkey=#{self.server[location]['hashkey']}&location=#{location}&#{value}")
  end

  listen_for /(#{KEYWORDS_ZUHAUSE}) (.*)/i do |location,values|
    #Thread.new do
      values = values.gsub(/ß/, "sS")
      result = IPSRequest('ZUHAUSE',"location=ZUHAUSE&values=#{values}")
      #say "#{result}"#, spoken: ""
      eval(result)
      request_completed
    #end
  end
  
end